From 825ad27691dfba1edbe8401686bd6a7ed8f51d73 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:37:02 +0000
Subject: [PATCH 821/2232] Create dir for the links in the target dir


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index a36f925..9a1ad0a 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -174,8 +174,10 @@ fn generate_bridge(prj: &Project, build: &mut Build, rust_source_file: &Path) ->
     write(header_path, &generated.header)?;
     paths::symlink_namespaced(header_path, &prj.out_dir, rel_path);
     if let TargetDir::Path(target_dir) = &prj.target_dir {
-        paths::symlink_namespaced(header_path, target_dir, rel_path);
-        paths::symlink_namespaced(header_path, target_dir, rel_path_h);
+        let ref link_path = paths::namespaced(target_dir, rel_path);
+        let _ = fs::create_dir_all(link_path.parent().unwrap());
+        let _ = paths::symlink_or_copy(header_path, link_path);
+        let _ = paths::symlink_or_copy(header_path, link_path.with_appended_extension(".h"));
     }
 
     let ref rel_path_cc = rel_path.with_appended_extension(".cc");
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 1a423dc..c3238b3 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -100,10 +100,10 @@ pub(crate) fn search_parents_for_target_dir(out_dir: &Path) -> TargetDir {
 }
 
 #[cfg(unix)]
-use self::fs::symlink_file as symlink_or_copy;
+pub(crate) use self::fs::symlink_file as symlink_or_copy;
 
 #[cfg(windows)]
-fn symlink_or_copy(src: &Path, dst: &Path) -> Result<()> {
+pub(crate) fn symlink_or_copy(src: &Path, dst: &Path) -> Result<()> {
     // Pre-Windows 10, symlinks require admin privileges. Since Windows 10, they
     // require Developer Mode. If it fails, fall back to copying the file.
     if fs::symlink_file(src, dst).is_err() {
@@ -113,7 +113,7 @@ fn symlink_or_copy(src: &Path, dst: &Path) -> Result<()> {
 }
 
 #[cfg(not(any(unix, windows)))]
-use self::fs::copy as symlink_or_copy;
+pub(crate) use self::fs::copy as symlink_or_copy;
 
 #[cfg(any(unix, windows))]
 pub(crate) use self::fs::symlink_dir;

